#include <bits/stdc++. h>

using namespace std;

int main ()
{
    int n, a, b, o, ab;
    int m=0;
    string kg;
    cin>>n;
    cin>>o>>a>>b>>ab;
    int matrica[n][4];
    for(int i=0; i<n; i++){
        for(j=0; j<4; j++){
            a[i][j]=0;
        }
    }
    for(int i=0; i<n; i++){
        int j = 0;
        cin>>kg>>j;
        if(kg == "O") {
            if((o>=j) {
                a[i][0]=j;
                o=o-j;
            } 
            else{
                cout<<"nemoguce";
                m=1;
                return 0;
                }
        }
       else if(kg == "A"){
           if((a>=j){
               a[i][1]=j;
               a=a-j;
           }
           else {
               a[i][1]=a;
               j=j-a;
               if((o>=j) {
                a[i][0]=j;
                o=o-j;
            } 
                else {
                cout<<"nemoguce";
                m=1;
                return 0;
                }
           }
       }
       else if(kg == "B"){
           if((b>=j){
               a[i][2]=j;
               b=b-j;
           }
           else {
               a[i][2]=b;
               j=j-b;
               if((o>=j) {
                a[i][0]=j;
                o=o-j;
            } 
                else {
                cout<<"nemoguce";
                m=1;
                return 0;
                }
           }
       }

    }
    if(m != 1){
        for(int i=0; i<n; i++){
            cin>>kg>>j;
            if(kg == "AB"){
                if(ab>=j){
                    a[i][3]=j;
                    ab=ab-j;
                }
                else {
                    a[i][3]=ab;
                    j=j-ab;
                    if(b>=j){
                        a[i][2]=j;
                        b=b-j;
                    }
                    else{
                        a[i][2]=b;
                        j=j-b;
                        if(a>=j){
                            a[i][1]=j;
                            a=a-j;
                        }
                        else {
                            a[i][1]=a;
                            j=j-a;
                            if((o>=j) {
                                a[i][0]=j;
                                o=o-j;
                            } 
                            else {
                                cout<<"nemoguce";
                                return 0;
                            }
                        }
                    }
                }
            }
        }
    }
    
    return 0;
}